package org.zeroturnaround.javarebel.integration.servlet.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.RebelServletContext;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class JettyServletHandlerClassBytecodeProcessor extends
    JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getMethod("initialize", "(Lorg/mortbay/http/HttpContext;)V");
    m.insertAfter(
        "org.zeroturnaround.javarebel.ServletIntegrationFactory.getInstance()" +
        "    .registerServletContext((" + RebelServletContext.class.getName() + ") $0.getServletContext());");
    
  }
}
